/*
 GB Nintendo Logo Emulator - Write 1 example
 Author: Alex from Inside Gadgets (http://www.insidegadgets.com)
 
 */

// The nintendo logo
byte nintendoLogo[48] = {0xCE, 0xED, 0x66, 0x66, 0xCC, 0x0D, 0x00, 
0x0B, 0x03, 0x73, 0x00, 0x83, 0x00, 0x0C, 0x00, 0x0D, 0x00, 0x08, 
0x11, 0x1F, 0x88, 0x89, 0x00, 0x0E, 0xDC, 0xCC, 0x6E, 0xE6, 0xDD, 
0xDD, 0xD9, 0x99, 0xBB, 0xBB, 0x67, 0x63, 0x6E, 0x0E, 0xEC, 0xCC, 
0xDD, 0xDC, 0x99, 0x9F, 0xBB, 0xB9, 0x33, 0x3E};

void setup() {
  DDRD |= B00000000; // D2 - D7 as inputs (on GB reads A0-A5)
  DDRB |= B00011000; // D8 - D9 as input (on GB reads A6-A7), D11 - D12 as outputs (on GB writes D6-D7)
  DDRC |= B00111111; // A0 - A5 as outputs (on GB writes D0-D5)
}

void loop() {
 
  byte addressLines = PIND >> 2;
  while (addressLines == 0) {
    addressLines = PIND >> 2; // Only read address lines A0-A6 as others aren't needed
    if (addressLines > 0) { // Hit the noise
      delay(50);
    }
  }
  
  boolean readyToOutput = false;
  while (addressLines != 68) { // Indicates the end of reading the header
    while (addressLines >= 250) { // Ignore this data as it's not related to the header  
       addressLines = (PINB << 6) | (PIND >> 2);
    }
    
    // Read the address lines A0-A8
    addressLines = ((PINB << 6) | (PIND >> 2));
    
    if (addressLines == 4) { readyToOutput = true; }
    
    // Start at position 1 on in nintendoLogo array
    if (addressLines >= 4 && addressLines <= 51 && readyToOutput == true) {
      PORTC = nintendoLogo[addressLines-4];
      PORTB = ((nintendoLogo[addressLines-4] & 192) >> 3);
    }
  }
  
  // Turn off outputs
  PORTC = 0;
  PORTB &= ~B00011000;
}